<?php
// Addon identification for the roster admin interface
$addon_name = 'Authentication System';
$addon_version = '1.1';
$addon_creator_name = 'Michael Birnbaum';
$addon_creator_nick = 'Silencer-ch-au';
$addon_creator_email = 'my_fire_and_ice@hotmail.com';
$addon_description = 'This associates your CMS users with their wow char names on the roster';
$addon_folder_name = 'authenticationSystem';
$addon_pic_path = 'images/INV_Misc_Key_04.jpg';
$addon_settings_qstring = 'authenticationSettings';
### List the tables for this Addon ###
$addon_tables[0] = 'authenticationsystem_settings';
### List the upgrade filename, without .sql ###
$upgrade_tables[0] = 'upgrade';


if($_REQUEST['roster_addon_name'] !== "addonAdmin"){ // Dont execute the rest if the admin page is scanning for addons.
	// Get database settings
	if(file_exists("../../conf.php")){
		chdir('../../');
		require_once 'conf.php';
		chdir('addons/'.$addon_folder_name);
	} else { 
		print "<hr>Something's wrong with the path settings in: <br><b>"
		.$_SERVER['SCRIPT_FILENAME']."<br>".$_SERVER['PHP_SELF'].
		"</b><br>Please check if you have put this addon's folder into the right place. roster/addons/<hr>";
	}
	
	// CMS ID Array
	$IDNames = array("e107_6"=>"e107 v6xx", 
					 "e107_7"=>"e107 v7xx", 
					 "phpBB"=>"PHPBB2", 
					 "nuke"=>"PHP Nuke",
					 "postnuke"=>"Post Nuke",
					 "dragonfly"=>"Dragonfly", 
					 "wbb"=>"Woltlab Burning Board", 
					 "IPB"=>"Invision Power Board", 
					 "vB"=>"vBulletin",
					 #"joomla"=>"Joomla", 
					 "unb"=>"Unclassified News Board", 
					 "phpfusion"=>"PHPFusion",
					 "tikiwiki"=>"Tikiwiki",
					 "smf"=>"Simple Machines Forum",
					 "minibb"=>"MiniBB"
					 );
	
	// Define static table references to provide for table prefixes
		define('ROSTER_ADDON_AUTHENTICATIONSETTINGSTABLE',$db_prefix.$addon_tables[0]);
	
	// Get database access functions
	require_once 'lib/db.php';
	
	
	// Check if the tables exist
	$DBfunctions = new DBfunctions;
	$DBfunctions->connect();
	foreach($addon_tables as $tableName){
		if($DBfunctions->getCount($DBfunctions->query("SHOW TABLES LIKE '".$db_prefix.$tableName."'"))!==1) 
		print "Table ".$db_prefix.$tableName." could not be found, chances are that you haven't installed the Addon '".$addon_name."' from the admin page";
	}
	
	// Get localized text
	global $roster_lang;
	require_once 'localization/'.$roster_lang.'.php';

if($_REQUEST['roster_addon_name'] !== "authenticationSystem" ){

	// Load the class with the addon's functions
	require_once 'authentication.php';
}
}
?>