<?php

// standard hack prevent
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

// standard session management
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

// set page title
$page_title = 'Character Management Page';

// standard page header
include($phpbb_root_path . 'includes/page_header.'.$phpEx);


// Kick out those who do not belong
if ($userdata['username'] == "Anonymous")
	message_die(GENERAL_ERROR, "You need to be logged in to be able to access this page. kthxbai");
	

// Alliance and Horde ranks
/*$ranks = array("[Rank 0] No Rank", "[Rank 1] Private", "[Rank 2] Corporal", "[Rank 3] Sergeant", "[Rank 4] Master Sergeant", "[Rank 5] Sergeant Major",
				"[Rank 6] Knight", "[Rank 7] Knight-Lieutenant", "[Rank 8] Knight-Captain", "[Rank 9] Knight-Champion", "[Rank 10] Lieutenant Commander",
				"[Rank 11] Commander", "[Rank 12] Marshal", "[Rank 13] Field Marshal", "[Rank 14] Grand Marshal");*/

$ranks = array("[Rank 0] No Rank", "[Rank 1] Scout", "[Rank 2] Grunt", "[Rank 3] Sergeant", "[Rank 4] Senior Sergeant", "[Rank 5] First Sergeant",
				"[Rank 6] Stone Guard", "[Rank 7] Blood Guard", "[Rank 8] Legionnaire", "[Rank 9] Centurion", "[Rank 10] Champion",
				"[Rank 11] Lieutenant General", "[Rank 12] General", "[Rank 13] Warlord", "[Rank 14] High Warlord");


// Variable retrieval
$mode = $HTTP_GET_VARS['mode'];


//Let's rock!
if ($mode == "add")
{
	$user_id = $userdata['user_id'];
	$name = $_POST['name'];
	$rank = $_POST['rank'];
	$lvl  = $_POST['lvl'];
	$class= $_POST['class'];
	$race = $_POST['race'];
	$prof1= $_POST['prof1'];
	$prof1lvl = $_POST['prof1lvl'];
	$prof2= $_POST['prof2'];
	$prof2lvl = $_POST['prof2lvl'];
	
	// Info needed
	if (!$name || !$rank || !$lvl || !$class || !$race)
		message_die(GENERAL_ERROR, "You did not fill out all the required information. Please go back and fill out all fields.");
	if ($lvl > 60)
		message_die(GENERAL_ERROR, "You cannot be higher than lvl 60.");
	if ($prof1lvl > 315 || $prof2lvl > 315)
		message_die(GENERAL_ERROR, "Your profession level must not be higher than 315.");
	
	// This next bit of code finds out whether main should be true or false:
	$main = 0;
	$sql = "SELECT main FROM phpbb_characters WHERE user_ID = $user_id";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	while ($row = $db->sql_fetchrow($result))
		$main++;
	if ($main == 0)
		$main = 1;
	else
		$main = 0;
	$db->sql_freeresult($result);
	
	
	$sql = "INSERT INTO phpbb_characters (user_ID, main, name, rank, lvl, class, race, prof1, prof1lvl, prof2, prof2lvl)
			VALUES ('$user_id', '$main', '$name', '$rank', '$lvl', '$class', '$race', '$prof1', '$prof1lvl', '$prof2', '$prof2lvl')";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	//$db->sql_freeresult($result);
	
	message_die(GENERAL_MESSAGE, "Your character has been added to the database.<br><br>
								  Click <a href=\"char_edit.php\">here</a> to return to your character management page.<br><br>
								  Click <a href=\"characters.php\">here</a> to return to the main characters page.");
}
else if ($mode == "addform")
{
	$ranks_html = "<select name=\"rank\"><option value=\"0\" SELECTED>Select one:</option>";
	
	for ($i = count($ranks)-1; $i >= 0; $i--)
		$ranks_html .= "<option value=\"" . $ranks[$i] . "\">" . $ranks[$i] . "</option>";
	
	$ranks_html .= "</select>";
	
	$template->assign_vars(array(
		'RANKS' => $ranks_html)
		);
	
	// assign template
	$template->set_filenames(array(
			'body' => 'char_edit_add.tpl')
	);
}
else if ($mode == "edit")
{
	$ID = $_POST['ID'];
	$lvl = $_POST['lvl'];
	$rank = $_POST['rank'];
	$prof1 = $_POST['prof1'];
	$prof2 = $_POST['prof2'];
	$prof1lvl = $_POST['prof1lvl'];
	$prof2lvl = $_POST['prof2lvl'];
	
	if (!$lvl || !$rank)
		message_die(GENERAL_ERROR, "You did not fill out all the required information. Please go back and fill out all fields.");
	if ($lvl > 60)
		message_die(GENERAL_ERROR, "You cannot be higher than lvl 60.");
	if ($prof1lvl > 315 || $prof2lvl > 315)
		message_die(GENERAL_ERROR, "Your profession level must not be higher than 315.");
	
	$sql = "UPDATE phpbb_characters
			SET lvl = '$lvl', rank = '$rank', prof1 = '$prof1', prof1lvl = '$prof1lvl', prof2 = '$prof2', prof2lvl = '$prof2lvl'
			WHERE ID = $ID
			LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	//$row = $db->sql_fetchrow($result);
	//$db->sql_freeresult($result);
	
	message_die(GENERAL_MESSAGE, "Your character has been successfully modified.<br><br>
								  Click <a href=\"char_edit.php\">here</a> to return to your character management page.<br><br>
								  Click <a href=\"characters.php\">here</a> to return to the main characters page.");
}
else if ($mode == "editform")
{
	$ID = $HTTP_GET_VARS['ID'];
	
	// Get current info
	$sql = "SELECT user_ID, name, rank, lvl, class, race, prof1, prof1lvl, prof2, prof2lvl
			FROM phpbb_characters
			WHERE ID = $ID
			LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	if ($userdata['user_id'] != $row['user_ID'])
		message_die(GENERAL_ERROR, "This character does not belong to you!");
	
	
	$name = $row['name'];
	$rank = $row['rank'];
	$lvl = $row['lvl'];
	$class = $row['class'];
	$race = $row['race'];
	$prof1 = $row['prof1'];
	$prof2 = $row['prof2'];
	$prof1lvl = $row['prof1lvl'];
	$prof2lvl = $row['prof2lvl'];
	
	
	$ranks_html = "<select name=\"rank\">";
	
	for ($i = count($ranks)-1; $i >= 0; $i--)
	{
		if ($rank == $ranks[$i])
			$ranks_html .= "<option value=\"" . $ranks[$i] . "\" SELECTED>" . $ranks[$i] . "</option>";
		else
			$ranks_html .= "<option value=\"" . $ranks[$i] . "\">" . $ranks[$i] . "</option>";
	}
	
	$ranks_html .= "</select>";
	
	$template->assign_vars(array(
		'ID' => $ID,
		'NAME' => $name,
		'RANKS' => $ranks_html,
		'LVL' => $lvl,
		'CLASS' => $class,
		'RACE' => $race,
		'PROF1' => $prof1,
		'PROF2' => $prof2,
		'PROF1LVL' => $prof1lvl,
		'PROF2LVL' => $prof2lvl)
		);
	
	// assign template
	$template->set_filenames(array(
			'body' => 'char_edit_edit.tpl')
	);
}
else if ($mode == "delete")
{
	$ID = $HTTP_GET_VARS['ID'];
	
	//Check if this user is allowed to delete this char
	$sql = "SELECT user_ID FROM phpbb_characters WHERE ID = '$ID' LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	if ($userdata['user_id'] != $row['user_ID'])
		message_die(GENERAL_ERROR, "Your are not allowed to delete characters that do not belong to you.");
	
	$sql = "DELETE FROM phpbb_characters WHERE ID = '$ID' LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	//$row = $db->sql_fetchrow($result);
	//$db->sql_freeresult($result);
	
	message_die(GENERAL_MESSAGE, "Your character has been successfully removed.<br><br>
								  Click <a href=\"char_edit.php\">here</a> to return to your character management page.<br><br>
								  Click <a href=\"characters.php\">here</a> to return to the main characters page.");
}
else if ($mode == "changemain")
{
	// Change all old characters to be set as non-mains:
	$user_id = $userdata['user_id'];
	$sql = "UPDATE phpbb_characters SET main = 0 WHERE user_ID = $user_id";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	//$db->sql_freeresult($result);
	
	// make the new character main:
	$main = $_POST['main'];
	$sql = "UPDATE phpbb_characters SET main = 1 WHERE ID = $main LIMIT 1";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	//$db->sql_freeresult($result);
	
	// done, forwarding. . .
	message_die(GENERAL_MESSAGE, "Your main character has been changed.<br><br>
								  Click <a href=\"char_edit.php\">here</a> to return to your character management page.<br><br>
								  Click <a href=\"characters.php\">here</a> to return to the main characters page.");
}
else
{
	// assign template
	$template->set_filenames(array(
			'body' => 'char_edit_main.tpl')
	);
	
	
	$drop_change = "<select name=\"main\">";
	
	// top table:
	$sql = "SELECT ID, main, user_ID, name, lvl, class, race
	FROM phpbb_characters
	ORDER BY ID ASC";
	if( !($result = $db->sql_query($sql)) )
		message_die(GENERAL_ERROR, 'Could not query users', '', __LINE__, __FILE__, $sql);
	
	if ( $row = $db->sql_fetchrow($result) )
	{
		$i = 0;
		do
		{
			if ($row['user_ID'] == $userdata['user_id'])
			{
				// Start retreiving information
				$ID = $row["ID"];
				$charname = $row['name'];
				$level = $row['lvl'];
				$class = $row['class'];
				$race = $row['race'];
				$main = $row['main'];
				
				$main =  ($main) ? "[main]" : "";
		
				$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
				$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
				
				$drop_change .= "<option value=\"$ID\">$charname</option>";
		
				$template->assign_block_vars('memberrow', array(
					'ROW_NUMBER' => $i + ( $start + 1 ),
					'ROW_COLOR' => '#' . $row_color,
					'ROW_CLASS' => $row_class,
					
					'CHARACTER' => $charname,
					'COL3' => "lvl " . $level . " " . $race . " " . $class,
					'MAIN' => $main,
					'EDIT' => "<form method=\"POST\" action=\"char_edit.php?mode=editform&ID=$ID\"><input type=\"submit\" value=\"Edit\" class=\"liteoption\"></form>",
					'DELETE' =>"<form method=\"POST\" action=\"char_edit.php?mode=delete&ID=$ID\"><input type=\"submit\" value=\"Delete\" class=\"liteoption\"></form>")
				);
		
				$i++;
			}
		} while ( $row = $db->sql_fetchrow($result) );
		$db->sql_freeresult($result);
	}
	
	$drop_change .= "</select>";
}



$template->assign_vars(array(
	'CHANGE' => $drop_change,
	'BOTTOM_COLOR' => $theme['td_class2'])
	);


$template->pparse('body');

// standard page footer
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>